/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the ContactCreatableLanguages type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ContactCreatableLanguages{}

// ContactCreatableLanguages struct for ContactCreatableLanguages
type ContactCreatableLanguages struct {
	Primary *string `json:"primary,omitempty"`
	Additional map[string]interface{} `json:"additional,omitempty"`
}

// NewContactCreatableLanguages instantiates a new ContactCreatableLanguages object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewContactCreatableLanguages() *ContactCreatableLanguages {
	this := ContactCreatableLanguages{}
	return &this
}

// NewContactCreatableLanguagesWithDefaults instantiates a new ContactCreatableLanguages object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewContactCreatableLanguagesWithDefaults() *ContactCreatableLanguages {
	this := ContactCreatableLanguages{}
	return &this
}

// GetPrimary returns the Primary field value if set, zero value otherwise.
func (o *ContactCreatableLanguages) GetPrimary() string {
	if o == nil || IsNil(o.Primary) {
		var ret string
		return ret
	}
	return *o.Primary
}

// GetPrimaryOk returns a tuple with the Primary field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactCreatableLanguages) GetPrimaryOk() (*string, bool) {
	if o == nil || IsNil(o.Primary) {
		return nil, false
	}
	return o.Primary, true
}

// HasPrimary returns a boolean if a field has been set.
func (o *ContactCreatableLanguages) HasPrimary() bool {
	if o != nil && !IsNil(o.Primary) {
		return true
	}

	return false
}

// SetPrimary gets a reference to the given string and assigns it to the Primary field.
func (o *ContactCreatableLanguages) SetPrimary(v string) {
	o.Primary = &v
}

// GetAdditional returns the Additional field value if set, zero value otherwise.
func (o *ContactCreatableLanguages) GetAdditional() map[string]interface{} {
	if o == nil || IsNil(o.Additional) {
		var ret map[string]interface{}
		return ret
	}
	return o.Additional
}

// GetAdditionalOk returns a tuple with the Additional field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactCreatableLanguages) GetAdditionalOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.Additional) {
		return map[string]interface{}{}, false
	}
	return o.Additional, true
}

// HasAdditional returns a boolean if a field has been set.
func (o *ContactCreatableLanguages) HasAdditional() bool {
	if o != nil && !IsNil(o.Additional) {
		return true
	}

	return false
}

// SetAdditional gets a reference to the given map[string]interface{} and assigns it to the Additional field.
func (o *ContactCreatableLanguages) SetAdditional(v map[string]interface{}) {
	o.Additional = v
}

func (o ContactCreatableLanguages) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ContactCreatableLanguages) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Primary) {
		toSerialize["primary"] = o.Primary
	}
	if !IsNil(o.Additional) {
		toSerialize["additional"] = o.Additional
	}
	return toSerialize, nil
}

type NullableContactCreatableLanguages struct {
	value *ContactCreatableLanguages
	isSet bool
}

func (v NullableContactCreatableLanguages) Get() *ContactCreatableLanguages {
	return v.value
}

func (v *NullableContactCreatableLanguages) Set(val *ContactCreatableLanguages) {
	v.value = val
	v.isSet = true
}

func (v NullableContactCreatableLanguages) IsSet() bool {
	return v.isSet
}

func (v *NullableContactCreatableLanguages) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableContactCreatableLanguages(val *ContactCreatableLanguages) *NullableContactCreatableLanguages {
	return &NullableContactCreatableLanguages{value: val, isSet: true}
}

func (v NullableContactCreatableLanguages) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableContactCreatableLanguages) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


